﻿using System;
using System.Text;

namespace PinEncoding
{
    class publicKey
    {
        private string uid;
        private string value;
        private string valueDecoded;
        private byte[] valueByte;

        public string Uid { get => uid; set => uid = value; }
        public string Value { get => value; set => this.value = value; }
        public string ValueDecoded { get => valueDecoded;  }
        public byte[] ValueByte { get => valueByte; set => valueByte = value; }

        public publicKey(string uid, string value)
        {
            Uid = uid;
            Value = value;
            valueByte = Convert.FromBase64String(value);
            valueDecoded = Encoding.UTF8.GetString(valueByte);
        }
    }
}
